<?php

$pic_save_path = "/tmp/pic/";
$log_save_path = "/tmp/Notfoundfile.log";
$flag = "flag{flag在此}";

//若指定图片目录不存在，则新建
if (!file_exists($pic_save_path)) {
	system("mkdir {$pic_save_path}");
}

function get_ext($file_name) {
	if (strpos($file_name, ".") !== FALSE) {
		//以.分个字符串
        $arr = explode('.', $file_name);
		//获取后缀名
		return end($arr);
	}
	return FALSE;
}
//检查文件后缀名是否符合要求
function check_images($file_name) {
    if (get_ext($file_name) !== FALSE) {
		//获取后缀名
        $end_ =  get_ext($file_name);
		//功能之前都写好了，懒得用正则了,不想再写一遍了
        if (($end_ == "jpg" || $end_ == "JPG") || ($end_ == "png" || $end_ == "PNG")  || ($end_ == "gif" || $end_ == "GIF") || ($end_ == "jpeg" || $end_ == "JPEG") || ($end_ == "jfif" || $end_ == "JFIF") || ($end_ == "webp" || $end_ == "WEBP")) {
            return true;
        }
    }
	return false;
}


//删除文件专用类
class delfile {
	public $base_dir;
	public $file_name;
	public $log_file_path;
	
	public function __construct($set_basedir, $SET_LOG_FILE) {
		$this->base_dir = $set_basedir;
		$this->log_file_path = $SET_LOG_FILE;
	}
	
	//标记需要删除的文件
	public function mark_file($set_file) {
		$this->file_name = $set_file;
	}
	
	//删除功能,文件必须存在且目录需要与$pic_save_path一致，不允许出现../
	public function del() {
		if (($this->file_name !== NULL && $this->file_name !== "")) {
			if ( file_exists($this->file_name) && $this->check_assert() ) {
					@unlink($this->file_name);
			} else {
				$this->filenotfound_recording();
			}
		}
	}

	//检查目录是否与$pic_save_path一致，是否出现../
	public function check_assert() {
		if ((substr($this->file_name, 0, strlen($this->base_dir)) === $this->base_dir) 
		&& ($this->check_path($this->file_name))) {
			return true;
		}
		return false;
	}
	
	//不允许../出现（不允许目录穿越）
	public function check_path($str) {
		if ((strpos($str, "../") !== FALSE) || (strpos($str, "..") !== FALSE)) {
			return false;
		}
		return true;
	}
	
	//Notfoundfile.log记录删除失败的文件名
	public function filenotfound_recording() {
		if ($this->log_file_path !== NULL || $this->log_file_path !== "") {
			$write = "Meet_notfound at file: {$this->file_name}\n";
			file_put_contents($this->log_file_path, $write, FILE_APPEND);
		}
	}
	
	public function __destruct() {
		$this->del();
	}
}